<?php

$script_dir = dirname(dirname($_SERVER['SCRIPT_FILENAME'])) . '/';
$script_name = dirname(dirname($_SERVER['SCRIPT_NAME'])) . 'index.php';
$script_file_name = $script_dir . 'index.php';

require_once $script_dir . 'php/vendor/autoload.php';

if (preg_match('@(.*?)([^/]+)$@', $_SERVER['SCRIPT_FILENAME'], $match)) {
    $scriptDir = $match[1];
    if (file_exists($scriptDir . '.env')) {
        Dotenv\Dotenv::createImmutable($scriptDir)->load();
    }
}
function env($key, $default = '') {
    return isset($_ENV[$key]) ? $_ENV[$key] : $default;
}

/**
 * config.server.php
 */
if ( !is_file($script_dir . 'config.server.php') ) {
    die('config.server.php is missing');
}

require_once $script_dir . 'config.server.php';
require_once $script_dir . PHP_DIR . 'config/app.php';

setPath($script_file_name, $script_name);

/**
 * autoload
 */
spl_autoload_register('autoload');

/**
 * application
 */
$config = appConfig();

$app = new Acms\Application();
$app->init($config['aliases'], $config['providers']);

/**
 * load license
 */
$app->loadLicense();